package com.example.despelc;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Vector;
import java.util.concurrent.CancellationException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

public class AlmacenSW_PHP_AsyncTask implements Almacen {

	 private Context contexto;

	 

	 public AlmacenSW_PHP_AsyncTask(Context contexto) {

	        this.contexto = contexto;

	 }

	  

	 public Vector<String> listaPuntuaciones(int cantidad) {

	        try {

	              TareaLista tarea = new TareaLista();

	              tarea.execute(cantidad);

	              return tarea.get(4, TimeUnit.SECONDS);

	        } catch (TimeoutException e) {

	              Toast.makeText(contexto, "Tiempo excedido al conectar",

	                            Toast.LENGTH_LONG).show();

	        } catch (CancellationException e) {

	              Toast.makeText(contexto, "Error al conectar con servidor",

	                            Toast.LENGTH_LONG).show();

	        } catch (Exception e) {

	              Toast.makeText(contexto, "Error con tarea asíncrona",

	                            Toast.LENGTH_LONG).show();

	        }

	        return new Vector<String>();

	 }

	  

	 private class TareaLista extends AsyncTask<Integer, Void, Vector<String>>{

	   @Override

	   protected Vector<String> doInBackground(Integer... cantidad){

	      //Copia el código que antes estaba en listaPuntuaciones()

          Vector<String> result = new Vector<String>();

          try {

                 URL url=new URL("http://sasosai.hostinazo.com/Deselc/lista.php"+ "?max="+cantidad[0]);

                 HttpURLConnection conexion = (HttpURLConnection) url.openConnection();

                 if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

                        BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));

                        String linea = reader.readLine();

                        while (!linea.equals("")) {

                               result.add(linea);

                               linea = reader.readLine();
                               

                        }

                        reader.close();
                     
                        return result;

                 } else {

                               Log.e("DesPelc", conexion.getResponseMessage());

                               return result;

                        }

          } catch (Exception e) {

                 Log.e("DesPelc", e.getMessage(), e);

                 return result;

          }

    }
}  


public void guardarPuntuacion(String nombre,int cantidad,String icono,String fecha){

       try {

             TareaGuardar tarea = new TareaGuardar();

             tarea.execute(nombre,String.valueOf(cantidad),icono ,String.valueOf(fecha));

             //tarea.get(4, TimeUnit.SECONDS);

       }  catch (CancellationException e) {

             Toast.makeText(contexto, "Error al conectar con servidor", Toast.LENGTH_LONG).show();

       } catch (Exception e) {

             Toast.makeText(contexto, "Error con tarea asíncrona", Toast.LENGTH_LONG).show();

       }

}

 

private class TareaGuardar extends AsyncTask<String, Void, Void> {

       @Override

       protected Void doInBackground(String... param) {

             try {
            	 
                    URL url = new URL("http://sasosai.hostinazo.com/Deselc/nueva.php"+
                    "?nombre="+param[0]+
                    "&cantidad="+param[1]+
                    "&icono="+param[2]+
                    "&fecha="+param[3]);
                    Log.i("URL definitiva",url.toString());
                        HttpURLConnection conexion = (HttpURLConnection) url .openConnection();

                        if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

                               BufferedReader reader = new BufferedReader(new
                                            InputStreamReader(conexion.getInputStream()));

                               String linea = reader.readLine();

                               if (!linea.equals("OK")) {

                                      Log.e("Asteroides","Error en servicio Web nueva");

                               }

                        } else {

                               Log.e("Asteroides", conexion.getResponseMessage());

                        }

                        conexion.disconnect();

                 } catch (Exception e) {

                        Log.e("Asteroides", e.getMessage(), e);

                 }

                    return null;

             }
       }

 public void borrarBibere(String id){

    try {

          TareaBorrar tarea = new TareaBorrar();

          tarea.execute(id);

          //tarea.get(4, TimeUnit.SECONDS);

    }  catch (CancellationException e) {

          Toast.makeText(contexto, "Error al conectar con servidor", Toast.LENGTH_LONG).show();

    } catch (Exception e) {

          Toast.makeText(contexto, "Error con tarea asíncrona", Toast.LENGTH_LONG).show();

    }

}



private class TareaBorrar extends AsyncTask<String, Void, Void> {

    @Override

    protected Void doInBackground(String... param) {

          try {
         	 
                 URL url = new URL("http://sasosai.hostinazo.com/Deselc/borrar.php"+
                 "?id="+param[0]);
                 Log.i("URL definitiva",url.toString());
                     HttpURLConnection conexion = (HttpURLConnection) url .openConnection();

                     if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

                            BufferedReader reader = new BufferedReader(new
                                         InputStreamReader(conexion.getInputStream()));

                            String linea = reader.readLine();

                            if (!linea.equals("OK")) {

                                   Log.e("Asteroides","Error en servicio Web nueva");

                            }

                     } else {

                            Log.e("Asteroides", conexion.getResponseMessage());

                     }

                     conexion.disconnect();

              } catch (Exception e) {

                     Log.e("Asteroides", e.getMessage(), e);

              }

                 return null;

          }
    }



public void modificarBibere(String id, String cant){

    try {

          TareaModificar tarea = new TareaModificar();

          tarea.execute(id,cant);

          //tarea.get(4, TimeUnit.SECONDS);

    }  catch (CancellationException e) {

          Toast.makeText(contexto, "Error al conectar con servidor", Toast.LENGTH_LONG).show();

    } catch (Exception e) {

          Toast.makeText(contexto, "Error con tarea asíncrona", Toast.LENGTH_LONG).show();

    }

}



private class TareaModificar extends AsyncTask<String, Void, Void> {

    @Override

    protected Void doInBackground(String... param) {

          try {
         	 
                 URL url = new URL("http://sasosai.hostinazo.com/Deselc/modificar.php"+
                 "?id="+param[0]+"&cant="+param[1]);
                 Log.i("URL definitiva",url.toString());
                     HttpURLConnection conexion = (HttpURLConnection) url .openConnection();

                     if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

                            BufferedReader reader = new BufferedReader(new
                                         InputStreamReader(conexion.getInputStream()));

                            String linea = reader.readLine();

                            if (!linea.equals("OK")) {

                                   Log.e("Asteroides","Error en servicio Web nueva");

                            }

                     } else {

                            Log.e("Asteroides", conexion.getResponseMessage());

                     }

                     conexion.disconnect();

              } catch (Exception e) {

                     Log.e("Asteroides", e.getMessage(), e);

              }

                 return null;

          }
    }



public Vector<String> listaRecetas(int cantidad){

    try {

          TareaListaReceta tarea = new TareaListaReceta();

          tarea.execute(cantidad);

          return tarea.get(4, TimeUnit.SECONDS);

    } catch (TimeoutException e) {

          Toast.makeText(contexto, "Tiempo excedido al conectar",

                        Toast.LENGTH_LONG).show();

    } catch (CancellationException e) {

          Toast.makeText(contexto, "Error al conectar con servidor",

                        Toast.LENGTH_LONG).show();

    } catch (Exception e) {

          Toast.makeText(contexto, "Error con tarea asíncrona",

                        Toast.LENGTH_LONG).show();

    }

    return new Vector<String>();

}



private class TareaListaReceta extends AsyncTask<Integer, Void, Vector<String>>{

@Override

protected Vector<String> doInBackground(Integer... cantidad){

  //Copia el código que antes estaba en listaPuntuaciones()

  Vector<String> result = new Vector<String>();

  try {

         URL url=new URL("http://sasosai.hostinazo.com/Deselc/listarRecetas.php"+ "?max="+cantidad[0]);

         HttpURLConnection conexion = (HttpURLConnection) url.openConnection();

         if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

                BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));

                String linea = reader.readLine();

                while (!linea.equals("")) {
                	Log.i("Linea leuda",linea);
                	if(!linea.equals("seacabo ")){
                       result.add(linea);

                       linea = reader.readLine();
                	}
                       

                }

                reader.close();
             
                return result;

         } else {

                       Log.e("DesPelc", conexion.getResponseMessage());

                       return result;

                }

  } catch (Exception e) {

         Log.e("DesPelc", e.getMessage(), e);

         return result;

  }

}
}



public Vector<String> listaIngredientes(int cantidad) {

    try {

          TareaIngredientes tarea = new TareaIngredientes();

          tarea.execute(cantidad);

          return tarea.get(4, TimeUnit.SECONDS);

    } catch (TimeoutException e) {

          Toast.makeText(contexto, "Tiempo excedido al conectar",

                        Toast.LENGTH_LONG).show();

    } catch (CancellationException e) {

          Toast.makeText(contexto, "Error al conectar con servidor",

                        Toast.LENGTH_LONG).show();

    } catch (Exception e) {

          Toast.makeText(contexto, "Error con tarea asíncrona",

                        Toast.LENGTH_LONG).show();

    }

    return new Vector<String>();

}



private class TareaIngredientes extends AsyncTask<Integer, Void, Vector<String>>{

@Override

protected Vector<String> doInBackground(Integer... cantidad){

  //Copia el código que antes estaba en listaPuntuaciones()

  Vector<String> result = new Vector<String>();

  try {

         URL url=new URL("http://sasosai.hostinazo.com/Deselc/listarIngredientes.php"+ "?max="+cantidad[0]);

         HttpURLConnection conexion = (HttpURLConnection) url.openConnection();

         if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

                BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));

                String linea = reader.readLine();

                while (!linea.equals("")) {

                       result.add(linea);

                       linea = reader.readLine();
                       

                }

                reader.close();
             
                return result;

         } else {

                       Log.e("DesPelc", conexion.getResponseMessage());

                       return result;

                }

  } catch (Exception e) {

         Log.e("DesPelc", e.getMessage(), e);

         return result;

  }

}
}  


}



